Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.collections.bag
Class PredicatedBag

    java.lang.Object
      |
      +--org.apache.commons.collections.collection.AbstractCollectionDecorator
            |
            +--org.apache.commons.collections.collection.AbstractSerializableCollectionDecorator
                  |
                  +--org.apache.commons.collections.collection.PredicatedCollection
                        |
                        +--org.apache.commons.collections.bag.PredicatedBag

All Implemented Interfaces:
  Bag, Collection, Serializable

Direct Known Subclasses:
  PredicatedSortedBag

public class PredicatedBag
extends PredicatedCollection
implements Bag

Decorates another `Bag` to validate that additions match a specified predicate.

This bag exists to provide validation for the decorated bag. It is normally created to decorate an empty bag. If an object cannot be added to the bag, an IllegalArgumentException is thrown.

One usage would be to ensure that no null entries are added to the bag.

    Bag bag = PredicatedBag.decorate(new HashBag(), NotNullPredicate.INSTANCE);

This class is Serializable from Commons Collections 3.1.

Since:
  Commons Collections 3.0
Version:
  $Revision: 1.8 $ $Date: 2004/06/03 22:02:12 $
Author:
  Stephen Colebourne, Paul Jack
See Also:
  Serialized Form

Field Summary

Fields inherited from class org.apache.commons.collections.collection.PredicatedCollection
`predicate`

Fields inherited from class org.apache.commons.collections.collection.AbstractCollectionDecorator
`collection`

Constructor Summary
`protected` | `PredicatedBag(Bag bag, Predicate predicate)` Constructor that wraps (not copies).

Method Summary
`boolean` | `add(Object object, int count)` Adds `nCopies` copies of the specified object to the Bag.
`static Bag` | `decorate(Bag bag, Predicate predicate)` Factory method to create a predicated (validating) bag.
`protected Bag` | `getBag()` Gets the decorated bag.
`int` | `getCount(Object object)` Returns the number of occurrences (cardinality) of the given object currently in the bag.
`boolean` | `remove(Object object, int count)` Removes `nCopies` copies of the specified object from the Bag.
`Set` | `uniqueSet()` Returns a `Set` of unique elements in the Bag.

Methods inherited from class org.apache.commons.collections.collection.PredicatedCollection
`add, addAll, decorate, validate`

Methods inherited from class org.apache.commons.collections.collection.AbstractCollectionDecorator
`clear, contains, containsAll, equals, getCollection, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, toArray, toArray, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.apache.commons.collections.Bag
`add, containsAll, iterator, remove, removeAll, retainAll, size`

Methods inherited from interface java.util.Collection
`addAll, clear, contains, equals, hashCode, isEmpty, toArray, toArray`

Constructor Detail

### PredicatedBag

    protected PredicatedBag(Bag bag,
                            Predicate predicate)

  Constructor that wraps (not copies).

  If there are any elements already in the bag being decorated, they are validated.

Parameters:
  `bag` - the bag to decorate, must not be null
  `predicate` - the predicate to use for validation, must not be null
Throws:
  `IllegalArgumentException` - if bag or predicate is null
  `IllegalArgumentException` - if the bag contains invalid elements

Method Detail

### decorate

    public static Bag decorate(Bag bag,
                               Predicate predicate)

  Factory method to create a predicated (validating) bag.

  If there are any elements already in the bag being decorated, they are validated.

  Parameters:
    `bag` - the bag to decorate, must not be null
    `predicate` - the predicate to use for validation, must not be null
  Returns:
    a new predicated Bag
  Throws:
    `IllegalArgumentException` - if bag or predicate is null
    `IllegalArgumentException` - if the bag contains invalid elements

### getBag

    protected Bag getBag()

  Gets the decorated bag.

  Returns:
    the decorated bag

### add

    public boolean add(Object object,
                       int count)

  Description copied from interface: `Bag`
  Adds `nCopies` copies of the specified object to the Bag.

  If the object is already in the `Bag.uniqueSet()` then increment its count as reported by `Bag.getCount(Object)`. Otherwise add it to the `Bag.uniqueSet()` and report its count as `nCopies`.

  Specified by:
    `add` in interface `Bag`
  Parameters:
    `object` - the object to add
    `count` - the number of copies to add
  Returns:
    `true` if the object was not already in the `uniqueSet`

### remove

    public boolean remove(Object object,
                          int count)

  Description copied from interface: `Bag`
  Removes `nCopies` copies of the specified object from the Bag.

  If the number of copies to remove is greater than the actual number of copies in the Bag, no error is thrown.

  Specified by:
    `remove` in interface `Bag`
  Parameters:
    `object` - the object to remove
    `count` - the number of copies to remove
  Returns:
    `true` if this call changed the collection

### uniqueSet

    public Set uniqueSet()

  Description copied from interface: `Bag`
  Returns a `Set` of unique elements in the Bag.

  Uniqueness constraints are the same as those in `Set`.

  Specified by:
    `uniqueSet` in interface `Bag`
  Returns:
    the Set of unique Bag elements

### getCount

    public int getCount(Object object)

  Description copied from interface: `Bag`
  Returns the number of occurrences (cardinality) of the given object currently in the bag. If the object does not exist in the bag, return 0.

  Specified by:
    `getCount` in interface `Bag`
  Parameters:
    `object` - the object to search for
  Returns:
    the number of occurrences of the object, zero if not found

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2004 Apache Software Foundation. All Rights Reserved.